name_list = ['Alice', 'Bob', 'Cynthia', 'Derek', 'Eustace', 'Francis', 'Gregg']
print(name_list)

result = name_list[1]
print(result)

result = name_list[5]
print(result)

result = name_list[2:5]
print(result)

result = name_list[1:6:2]
print(result)

result = name_list[:3]
print(result)

result = name_list[3:]
print(result)

result = name_list[:-2]
print(result)

result = name_list[-2:]
print(result)

def fun_multiplier(x):
    return lambda y: x * y

fun_doubler = fun_multiplier(2)
result = fun_doubler(5)
print(result)

result = fun_doubler(10)
print(result)

fun_tripler = fun_multiplier(3)
result = fun_tripler(5)
print(result)

result = fun_tripler(10)
print(result)

result = fun_multiplier(3)(23)
print(result)

from functools import partial


def part_fun_multiplier(num_one, num_two):
    return num_one * num_two


part_fun_doubler = partial(part_fun_multiplier, 2)

result = part_fun_doubler(5)
print(result)

result = part_fun_doubler(10)
print(result)

part_fun_tripler = partial(part_fun_multiplier, 3)

result = part_fun_tripler(5)
print(result)

result = part_fun_tripler(10)
print(result)


def fib_recursion(n):
    if n == 0:
        return 0
    elif n == 1:
        return 1
    else:
        return fib_recursion(n - 1) + fib_recursion(n - 2)


result = fib_recursion(10)
print(result)


def fib(x1, x2):
    def get_next_number():
        nonlocal x1, x2
        x3 = x1 + x2
        x1, x2 = x2, x3
        return x3

    return get_next_number


def fib_closure(n):
    f = fib(0, 1)

    for i in range(2, n + 1):
        num = f()

    return num


result = fib_closure(10)
print(result)

result = fib_closure(1000)
print(result)

result = fib_recursion(1000)
print(result)
